'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cancel = exports.fork = exports.call = exports.put = exports.select = undefined;

var _CommandTypes = require('./CommandTypes');

var select = exports.select = function select() {
  var selector = arguments.length <= 0 || arguments[0] === undefined ? function (state) {
    return state;
  } : arguments[0];

  return { type: _CommandTypes.SELECT, selector: selector };
};

var put = exports.put = function put(nextState) {
  return { type: _CommandTypes.PUT, nextState: nextState };
};

var call = exports.call = function call(fn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return { type: _CommandTypes.CALL, fn: fn, args: args };
};

var fork = exports.fork = function fork(actionCreator) {
  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }

  return { type: _CommandTypes.FORK, actionCreator: actionCreator, args: args };
};

var cancel = exports.cancel = function cancel(actionId) {
  return { type: _CommandTypes.CANCEL, actionId: actionId };
};